﻿package com.actionsnippet.qbox.objects{
	
	import flash.display.*
	import flash.events.*;
	
	import com.actionsnippet.qbox.*
	
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import Box2D.Dynamics.Joints.*;
	
	/**
	BoxObject is a subclass of {@link com.actionsnippet.qbox.QuickObject} and should only be instantiated with the {@link com.actionsnippet.qbox.QuickBox2D#addBox()} method.
	
	@author Zevan Rosser
	@version alpha 105
	*/
	public class BoxObject extends QuickObject {
				   
		public function BoxObject(qbox:QuickBox2D, params:Object){
			super(qbox, params);
		}
		
		override protected function defaultParams(p:Object):void{
			p.width = 1;
			p.height = 1;
		}
		
 
		override protected function build():void{
			var p:Object = params;
			
			var boxDef:b2PolygonDef = new b2PolygonDef();
			 
			boxDef.SetAsBox(p.width / 2, p.height / 2);
		
			boxDef.density = p.density;
			boxDef.friction = p.friction;
			boxDef.restitution = p.restitution;
			boxDef.filter.maskBits = p.maskBits;
			boxDef.filter.categoryBits = p.categoryBits;
			boxDef.filter.groupIndex = p.groupIndex;
			
			if (p.skin is Class){
			    bodyDef.userData = new p.skin();
				bodyDef.userData.width=p.width * 30;
			    bodyDef.userData.height=p.height * 30;
			}else if (p.skin != "none"){
				bodyDef.userData = new Sprite();
				with(bodyDef.userData.graphics){
					lineStyle(p.lineThickness,p.lineColor, p.lineAlpha);
					beginFill(p.fillColor, p.fillAlpha);
					drawRect(-5,-5,10,10);
				}
				bodyDef.userData.width=p.width * 30;
			    bodyDef.userData.height=p.height * 30;
			}
			
			
			body =w.CreateBody(bodyDef);
			shape = body.CreateShape(boxDef);
			
		}
	}
}