﻿package com.actionsnippet.qbox.objects{
	
	import flash.display.*
	import flash.events.*;
	
	import com.actionsnippet.qbox.*
	
	import Box2D.Dynamics.*;
	import Box2D.Collision.*;
	import Box2D.Collision.Shapes.*;
	import Box2D.Common.Math.*;
	import Box2D.Dynamics.Joints.*;
	
	/**
	PolyObject is a subclass of {@link com.actionsnippet.qbox.QuickObject} and should only be instantiated with the {@link com.actionsnippet.qbox.QuickBox2D#addPoly()} method.
	
	@author Zevan Rosser
	@version alpha 105
	*/
	
	public class PolyObject extends QuickObject {
				   
		public function PolyObject(qbox:QuickBox2D, params:Object){
			super(qbox, params);
		}
		
		override protected function defaultParams(p:Object):void{
			p.verts = [[-.5, -1, 1, -1, 1, 1, -1, 1]];
		}
		
		override protected function build():void{
			 
			var p:Object = params;
			 
			
			var autoSkin:Boolean = false;
			if (p.skin is Class){
					bodyDef.userData = new p.skin();
			}else if(p.skin != "none"){
					bodyDef.userData = new Sprite();
					autoSkin = true;
			}
			body = w.CreateBody(bodyDef);
				
			for (var j:int = 0; j<p.verts.length; j++){
				var polyDef:b2PolygonDef = new b2PolygonDef();
				
				polyDef.vertexCount = int(p.verts[j].length / 2);
				
				if (p.verts[j][i] is b2Vec2){
						polyDef.vertices = p.verts[j];
				}else{
					var inc:int = 0;
					for (var i:int = 0; i<p.verts[j].length; i+=2){
						polyDef.vertices[inc].Set(p.verts[j][i], p.verts[j][i + 1]);
						inc++;
					}
				}
				
				polyDef.density = p.density;
				polyDef.friction = p.friction;
				polyDef.restitution = p.restitution;
				polyDef.filter.maskBits = p.maskBits;
			    polyDef.filter.categoryBits = p.categoryBits;
			    polyDef.filter.groupIndex = p.groupIndex;
				
				 if (autoSkin){
					with(bodyDef.userData.graphics){
							lineStyle(p.lineThickness,p.lineColor, p.lineAlpha);
					        beginFill(p.fillColor, p.fillAlpha);
					}
					for (i  =0; i<polyDef.vertexCount; i++){
						with(bodyDef.userData.graphics){
							if (i == 0){
								moveTo(polyDef.vertices[i].x * 30, polyDef.vertices[i].y * 30);
							}else{
								lineTo(polyDef.vertices[i].x * 30, polyDef.vertices[i].y * 30);
							}
						}
					}
					bodyDef.userData.graphics.endFill();
				}
				shape = body.CreateShape(polyDef);
			}
		}
	}
}